/***************************************************************************
    feuerwehr.h  fr  KWA - Kanadische Waldbrand Austreter
    Lschzug,  Klassen-Definition
                             -------------------
    begin                : Sat Sep 30 2000
    copyright            : (C) 2000 by Ulrich Bochert
    email                : schroeder_bochert@t-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef FEUERWEHR_H
#define FEUERWEHR_H

#include "kwa.h"

class FeuerWehr : public QObject
{
        Q_OBJECT
public:
        FeuerWehr(int name, float x, float y, int Zeile, int Spalte, double
                Richtung, int Benzin, int Wasser);
        void    init(int name, float x, float y, int Zeile, int Spalte, double
                Richtung, int Benzin, int Wasser);
        float   getXPos();
        float   getYPos();
        void   setXPos(double);
        void   setYPos(double);

        void    fahren(float BenzinVerbrauch);

        double  getRichtung();
        void    setRichtung(double);
        void    setRichtung(int, int);//Richtung wird aus x,y-Koordinate relativ zur Fw errechnet         double getRichtung();

        double  getFahrt();
        void    setFahrt(double);

        int     getBenzin();
        void    setBenzin(int);

        double  getWasser();
        void    setWasser(double);

        bool    getSelected();
        void    setSelected(bool);

        bool    getWillLoeschen();
        void    setWillLoeschen(bool);

        bool    getAbgebrannt();
        void    setAbgebrannt(bool);
protected:
private:
        int name;
        float x;
        float y;
        double Benzin;
        int BenzinAlt;
        double Wasser;
        int WasserAlt;
        double Fahrt;
        double Richtung;
        int aktiv;
        int z;
        int s;
        bool selected;
        bool willLoeschen;
        bool Abgebrannt;

signals:
        void WillLoeschenChanged(bool);
        void RichtungChanged(double);
        void FahrtChanged(double);
        void BenzinChanged(int);
        void WasserChanged(int);

public slots:
        void WillLoeschenSlot(bool);
        void RichtungSlot(double);
        void FahrtSlot(double);
};
#endif //FEUERWEHR_H
